//
// Created by cr on 06/02/23.
//

#include "FWIReceiverTimeseries.hpp"

FWIReceiverTimeseries::FWIReceiverTimeseries(int state_comps) : state_comps(state_comps) {}

FWIReceiverTimeseries::FWIReceiverTimeseries(const FWIReceiverTimeseries &ts) : state_comps(ts.state_comps) {
  for (const auto & t : ts) {
    auto *s = new FWIState(*t.second);
    push_back(std::make_pair(t.first, s));
  }
}

FWIReceiverTimeseries::~FWIReceiverTimeseries() {
  for (auto & i : *this)
    delete i.second;
  clear();
}


void FWIReceiverTimeseries::setStateComponents(int comps){ state_comps = comps; }