//
// Created by cr on 06/02/23.
//
#include <stdio.h>
#include <malloc.h>
#include "IFOSToFWI.hpp"
#include "segy.h"
#define SHIFT_IND 1
float **matrix(int mrl, int mrh, int mcl, int mch){

  int k,l, mrow=mrh-mrl+1,mcol=mch-mcl+1;
  float **ma;

  ma=(float **) malloc((size_t) ((mrow+SHIFT_IND)*sizeof(float*)));
  ma += SHIFT_IND;
  ma -= mrl;

  ma[mrl]=(float *) malloc((size_t)((mrow*mcol+SHIFT_IND)*sizeof(float)));
  ma[mrl] += SHIFT_IND;
  ma[mrl] -= mcl;

  for (k=mrl+1;k<=mrh;k++) ma[k]=ma[k-1]+mcol;

  for (k=mrl;k<=mrh;k++)
    for (l = mcl; l <= mch; l++) { ma[k][l] = 0.0; }

  return ma;
}
int readIFOS(char *DATA_DIR,char *DATA_NAME, int nrSeismos, int ntr_glob,int NT) {
  segy tr;
  float dump;
  float **sectionread=nullptr;
  sectionread=matrix(1,ntr_glob,1,NT);
  FILE *fpdata;
  char data[70]  = "/home/cr/CLionProjects/readdata/dt0.002_ts0.5_p.su.shot1";
//  fpdata = fopen(data,"r");
  int succread;
  for (int i = 1; i< nrSeismos; ++i) {
    sprintf(data, "%s%s%d", DATA_DIR, DATA_NAME, i);
    fpdata = fopen(data,"r");
    for (int tracl1 = 1; tracl1 <= ntr_glob; tracl1++) {        /* SEGY (without file-header) */
      succread = fread(&tr, 240, 1, fpdata);
      succread = fread(&tr.data, 4, NT, fpdata);
//      printf("%d\n", succread);
      sectionread[tracl1][1] = 0.0;
      for (int j = 1; j <= NT; j++) {
        dump = tr.data[j];
//        printf("%f,\n", dump);
        sectionread[tracl1][j + 1] = dump;
      }
    }
  }
  fclose(fpdata);
  return 0;
}