//
// Created by lionbart on 27.03.23.
//

#ifndef FWI_FWILINOPADJRED_H
#define FWI_FWILINOPADJRED_H

#include "Observation/FWISeismogram.hpp"
#include "Vector.hpp"

class FWILinOpAdjRed {
public:
    FWILinOpAdjRed() = default;
    virtual ~FWILinOpAdjRed() = default;

    virtual void CalculateAdjoint(const FWISeismogram &s, Vector &AdjointVector, Vectors *LambdaFull) = 0;

    virtual void calculateL2AdjointStep(const Vector &LambdaStep, Vector &AdjointVector, int step) = 0;
};
#endif //FWI_FWILINOPADJRED_H
