//
// Created by cr on 15/02/23.
//

#ifndef FWI_FWILINOPRED_HPP
#define FWI_FWILINOPRED_HPP


#include "Vector.hpp"
#include "Observation/FWIObservationDGTSNEW.hpp"

class FWILinOpRed {
public:
  FWILinOpRed() = default;
  virtual ~FWILinOpRed() = default;
  virtual void Solve(const Vector &m_test, Vectors &U_linearized) = 0;

  virtual void SolveAndMeasure(const Vector &m_test, const FWIObservationOperatorNEW &Obs,
                       FWISeismogram &s_linearized, Vectors *U_linearized) = 0;
};


#endif //FWI_FWILINOPRED_HPP
