//
// Created by cr on 24/03/23.
//

#include "FWITestReducedSO2D.hpp"
#include "FWITestReduced2D.hpp"
#include "TestEnvironment.hpp"
#include "FWINonlinearSolvers.hpp"

std::vector<std::vector<double>> FWIInverseMainDGTSVA();

class FWITestReduced2D : public Test {
public:
  FWITestReduced2D() {
    Config::Initialize(TestFWIReducedSO2DConfigMap);
  }

  void TearDown() override {
    Config::Close();
  }
};

TEST_F(FWITestReduced2D, TestFWIInverseMainDGTSVA) {
  std::vector<double> output = FWIInverseMainDGTSVA()[1];
  std::vector<double> input;
  input = {0.232664034663109,
           0.159569173745128,
           0.0822061597164788};
  std::cout << endl;
//  for (int i = 0; i < input.size(); i++) {
//    std::cout << output[i] << endl;
//
//    input[i] -= output[i];
//    input[i] *= 1.0 / output[i];
//  }
//  EXPECT_VECTOR_NEAR(input, std::vector<double>(input.size(), 0.0), 1e-10);
}

int main(int argc, char **argv) {
  return MppTest(
      MppTestBuilder(argc, argv).
          WithoutDefaultConfig().
          WithScreenLogging().
          WithConfPath("../").
          WithGeoPath("../conf/geo/").
          WithPlotPath("data/vtu/").
          WithFileLogging().//Diese beiden Befehle speichern Log files automatisch
          WithLogPath("log/").
          WithPPM()
  ).RUN_ALL_MPP_TESTS();
}