def create_config(config_input="",config_output ="",params=[]):
    filename = config_input
    f = open(filename, "r")
    Sf = f.read()
    if config_output is "":
        filename_tmp = filename.split('.conf')[0] + '_tmp.conf'
        print(filename_tmp)
    else:
        filename_tmp = config_output
    g = open(filename_tmp,"w+")
    paramlist = ''
    for param in params:
        paramlist = paramlist + param + ';\n'
    g.write(paramlist + Sf)
    f.close()
    g.close()

if __name__ == "__main__":
    import sys
    import argparse
    parser = argparse.ArgumentParser(description='Plot and compare seismograms')
    parser.add_argument('--config_input',type=str,nargs =1)
    parser.add_argument('--config_output',type=str,nargs=1)
    parser.add_argument('--param',type=str, nargs='+',
                    help='list of seismogram filenames')
    args = parser.parse_args()
    if args.config_input is None:
        print("no inputfile specified!")
        exit()
    if args.param is None:
        print("no parameters specified!")
        exit()
    if args.config_output is None:
        create_config(config_input = args.config_input[0],params=args.param)
    else:
        create_config(config_input = args.config_input[0], config_output = args.config_output[0],params=args.param)
