import os
import re
tool ='FWI/scripts/CreateConfig.py'
conf ='FWI/conf/GridStudy.conf'
cores = 4
nrfreq = 1
levelmin =1
levelmax =1
degmax = 2
degmin = 2
dt0 = 0.00256
nrdts = 2
f = open("gridstudy.sh", "w+")
freq1 = [25]
range1 = [i for i in range(1,nrfreq)]
freqs = freq1 + [i*5 for i in range1 if  i is not 5]
levels = [l for l in range(levelmin,levelmax+1)]
degs = [d for d in range(degmin,degmax+1)]
dts = [dt0*2**i for i in range(0,nrdts)]
dts = dts[::-1]
test = [(l,deg,dt) for l in levels for deg in degs for dt in dts]
pattern = '\/.*\/(.*)\.conf'
runconfig = re.findall(pattern,conf)[0] + '_tmp'
runfile = 'mpirun' + ' --hostfile m' +  ' -n ' + str(cores) + ' FWI_CR ' + runconfig
#runfile = 'mpirun -n ' + str(cores) + ' fwi ' + runconfig + '\n'
S = ''
rkorders = [-2]
for freq in freqs:
    for rk in rkorders:
	    for (l,deg,dt) in test:
#	        S = S + 'python3 ' + tool + ' -config_input ' + conf + ' -param ' + 'f_source=' + str(freq) + ' dt=' + str(dt)  + ' deg=' + str(deg) + ' level=' + str(l) + ' rkorder='+str(rk)+'\n'
#	        S = S + 'python3 ' + tool + ' -config_input ' + conf + ' -param ' + 'f_source=' + str(freq) + ' dt=' + str(dt)  + ' deg=' + str(deg) + ' level=' + str(l) + ' plevel='+ str(max(0,l-1)) + ' rkorder='+str(rk)+'\n'
                S = S + 'python3 ' + tool + ' --config_input ' + conf + ' --param ' + 'f_source=' + str(freq) + ' dt=' + str(dt)  + ' deg=' + str(deg) + ' level=' + str(l) + ' plevel='+ str(l) + ' rkorder='+str(rk)+'\n'
#       		S = S + runfile +  ' > ' + 'f_source=' + str(freq) + '_dt=' + str(dt)  + '_deg=' + str(deg) + '_level=' + str(l) + '_rkorder='+str(rk)+ '\n'
                S = S + runfile +  ' > ' + 'f_source=' + str(freq) + '_dt=' + str(dt)  + '_deg=' + str(deg) + '_level=' + str(l) + '_plevel='+ str(max(0,l-1)) + '_rkorder='+str(rk)+ '\n'
    S = S + 'mkdir data/FWI/f=' + str(freq) + '\n'
    S = S + 'mv data/FWI/s_* data/FWI/f=' +str(freq) + '/\n'
    S = S + 'mkdir data/FWI/f=' + str(freq) +'/log' + '\n'
    S = S + 'cp log/* data/FWI/f=' + str(freq) + '/log'
f.write(S)
f.close()
os.system('chmod +x gridstudy.sh')
os.system('mv gridstudy.sh ../../')
