#ifndef FWIINTEGRALOPERATOR_H
#define FWIINTEGRALOPERATOR_H
#include "FWIRKOperator.hpp"
class integralOperator {
    const RKOperator& RKOp;
    inteOptions opt;
    public:
    integralOperator(const RKOperator& _RKOp);
    void assembleInteRHS(Vectors &rhsWF, bool fwd);

    void integrateFWD(Vectors &WaveFieldEvaluation) const;
    void integrateBWD(Vectors &WaveFieldEvaluation) const;
    void run(const Vectors &WaveFieldPoint, Vectors &WaveFieldEvaluation) const;
};
#endif // FWIINTEGRALOP_H
