#include "FWIHelpers.hpp"
#include "FWIForwardModel.hpp"

#include <memory>

// ---------------------------------------------------------------------
// Method definitions



void FWIForwardModel::initializePrecon(const Vector &M, const Vector &M_update,
                                       const Vectors &U_M) {}

void FWIForwardModel::initializePrecon(const FWIDataContainerDomain &m,
                                       const FWIDataContainerDomain &m_update,
                                       const FWISubproblem &u_m) {}

void FWIForwardModel::applyPrecon(const FWIDataContainerDomain &m,
                                  FWIDataContainerDomain &m_update) { };

void FWIForwardModel::SetPenalty(const Vector &M_Upd, FWISubproblem &Defect) {
    Exit("implement in explicit classes")
};

FWISubproblem &operator*=(FWISubproblem &vec, double d) {
    for (auto &problem: vec) {
        problem *= d;
    }
    return vec;
}

FWISubproblem &operator-=(FWISubproblem &vec1, FWISubproblem &vec2) {
    for (size_t i = 0; i < vec1.size(); ++i) {
        vec1[i] -= vec2[i];
    }
    return vec1;
}

FWISubproblem &operator+=(FWISubproblem &vec1, FWISubproblem &vec2) {
    for (size_t i = 0; i < vec1.size(); ++i) {
        vec1[i] += vec2[i];
    }
    return vec1;
}

