//
// Created by cr on 17/01/23.
//

#ifndef FWI_SOURCEINVERSION_HPP
#define FWI_SOURCEINVERSION_HPP

#include "Observation/FWISeismogram.hpp"
#include "Problems/Sources/FWISourceWavelet.hpp"
#include "Observation/FWIObservationDGTSNEW.hpp"

void SourceInversion(const FWISeismogram &obs, const FWISeismogram &fwd, const Point &srcPos,
                     SourceWaveletBase &src, const FWIObservationOperatorSpace * SpOp, double eps,
                     double kappa);


#endif //FWI_SOURCEINVERSION_HPP
