//
// Created by cr on 03/03/23.
//

#include "FWITestSTI.hpp"
#include "TestEnvironment.hpp"
#include "Observation/FWISeismogram.hpp"
#include "Problems/Sources/FWISourceWavelet.hpp"
#include "Observation/FWIObservationDGTSNEW.hpp"
#include "SourceInversion.hpp"

class FWTTestSTI : public Test {
public:
  FWTTestSTI() {
    Config::Initialize();
  }

  void TearDown() override {
    Config::Close();
  }
};

TEST_F(FWTTestSTI, TestFWIInverseMainDGTSVA) {
//  string str1 = "IFOSFirstShotMeasuredpreSTF___";
//  string str2 = "ObsFilteredShot0BandPass2.0000004.000000___";
//FWISeismogram IFOSFwd(str1.c_str(),1);
//FWISeismogram IFOSObs(str2.c_str(),1);
////IFOSFwd.printObservation();
//SourceFromFile stf0("wavelet");
//FWIObservationOperatorSpace* SpObs = nullptr;
//Point srcPos(0,0,0);
//SourceInversion(IFOSObs,IFOSFwd,srcPos,stf0,SpObs, 0.005,0.0);
//stf0.WriteToFile("result");
}

int main(int argc, char **argv) {
  return MppTest(
      MppTestBuilder(argc, argv).
          WithoutDefaultConfig().
          WithScreenLogging().
          WithConfPath("../").
          WithGeoPath("../conf/geo/").
          WithPlotPath("data/vtu/").
          WithPPM()
  ).RUN_ALL_MPP_TESTS();
}