// $Header: https://svn.math.kit.edu/svn/M++/SummerSchool/TimeStepping/src/Main.C 838 2017-06-27 13:19:47Z wieners $

#include "m++.hpp"

void MaindG_Elasticity();
void MaindG_ViscoElastic();
void MaindG_Acoustic();
void MaindG_ViscoAcoustic();
void MaindG_ViscoAcousticX();
int main (int argv, char** argc) {
    SetSearchPath("TimeStepping",argv,argc);
    DPO dpo(&argv,&argc);
    std::string Model = "dGAcoustic";
    Config::Get("Model", Model);
    if (Model == "dGAcoustic") MaindG_Acoustic();
    else if (Model == "dGViscoAcoustic") MaindG_ViscoAcoustic();
    else if (Model == "dGViscoAcousticX") MaindG_ViscoAcousticX();
    else if (Model == "dGElasticity") MaindG_Elasticity();
    else if (Model == "dGViscoElastic") MaindG_ViscoElastic();
    else Exit("not implemented!");
    return 0;
}
