#!/bin/sh
### Job name
#SBATCH --job-name=MppFWILennart

### File for the output
##vorher#SBATCH --output=Mpp%A   ???????
#SBATCH --output=Mpp%A

### Time your job needs to execute
#SBATCH --time=222:00:00

### Use more than one node for parallel jobs on distributed-memory systems
###CR Version war 2, 4 geht, sofern genug frei.
#SBATCH --nodes=8
###SBATCH --nodes=1

### Number of CPUS per task
#SBATCH --cpus-per-task=1

### Disable hyperthreading by setting the tasks per core to 1
#SBATCH --ntasks-per-core=1

#SBATCH --mail-type=ALL

#SBATCH --mail-user=uuwyh@student.kit.edu

### Number of processes per node, in our case
#SBATCH --ntasks-per-node=16
mpirun M++
