from fwiPlot import PlotConfig, getBasicConfig, vtuPlotIterates, setParametersFromTickmiddleCamembert
#python3 plotC2MSD.py ausführen in console in dem ordner. Configs hier beachten.
Conf = getBasicConfig('C2', 'FWISO')
#Conf['ticks_middle'] = [0.9, 1, 1.05]
Conf['ticks_middle'] = [1]
Conf['vmin_diff'] = -0.1
Conf['vmax_diff'] = 0.1
#Conf['vmax_iterate'] = 1.1
Conf['vmax_iterate'] = 1.05
#Conf['vmin_iterate'] = 0.85
Conf['vmin_iterate'] = 0.95
Conf['plot_iterates'] = True
#final ist anzahl iterationen - 1
Conf['final'] = 5
Conf['normalization_value'] = 1/2000.0
Conf['data_name'] ='Rho'
#Conf['input_path'] = '/home/lionbart/Desktop/Logs_Plots_MA/2023_06_21_zVp15/'
#Conf['input_path'] = '/home/lionbart/Desktop/Logs_Plots_MA/2023_06_27_IC_RhoMono_HighResolution/vtuClipping/'
#Conf['input_path'] = '/home/lionbart/Desktop/Logs_Plots_MA/2023_06_27_noIC_VpMono_HighResolution/vtuClipping_iter5_secondTry/'
Conf['input_path'] = '/home/lionbart/Desktop/Logs_Plots_MA/2023_06_27_IC_RhoMono_HighResolution/vtuClipping/'
#Conf['input_path'] = '/home/lionbart/Desktop/Logs_Plots_MA/2023_06_27_noIC_VpMono_HighResolution/vtuClipping_quelle5/'

Conf['fn_input_true']='Rho_fwi_m_real.vtu'
Conf['fn_input_initial']='Rho_fwi_m_initial.vtu'
#Conf['fn_input_true']='Vp_fwi_m_real.vtu'
#Conf['fn_input_initial']='Vp_fwi_m_initial.vtu'
vtuPlotIterates(PlotConfig(Conf))

#python3 plotC2MSD.py ausführen in console in dem ordner. Configs hier beachten.

#Conf['fn_input_true']='Rho_fwi_m_real.vtu'
#Conf['fn_input_initial']='Rho_fwi_m_initial.vtu'
#Bei Multi ist einmal Vp und das andere mal Rho


#Conf['final'] = 11
#Conf['input_path'] = 'c2-aao-msd-with-damping/2022-07-29T16-41-45/0/vtu/'
#vtuPlotIterates(PlotConfig(Conf))
#Conf['input_path'] = 'c2-aao-msd-multiparam/2022-07-29_20:43:20/vtu/'
#Conf['data_name'] = 'TaupExp'
#Conf['ticks_middle'] = [0.45, 1, 2.0]
#Conf['vmin_diff'] = -0.1
#Conf['vmax_diff'] = 0.1
#Conf['vmax_iterate'] = 1.1
#Conf['vmin_iterate'] = 0.85
#Conf['fn_input_true'] = 'TaupExp_fwi_m_real.vtu'
#Conf['fn_input_initial'] = 'TaupExp_initialValue.vtu'
#Conf['normalization_value'] = 1.0 / 0.0767
#vtuPlotIterates(PlotConfig(Conf))
